variables:
  IMAGE_NAME: 'digit-c4/rps/nginx-docker-workflow'
  CI_REGISTRY_IMAGE: '${CI_REGISTRY}/${IMAGE_NAME}'

stages:
  # - PROJECT/DOCS
  - DOCKER/BUILD
  - DOCKER/PUBLISH
  - DOCKER/CLEAN

# pages:
#   stage: PROJECT/DOCS
#   image: python:3.12-slim-bookworm
#   rules:
#     - if: '$CI_COMMIT_BRANCH == "main"'
#   script:
#     - apt update && apt install -y make build-essential graphviz
#     - pip install poetry
#     - poetry install
#     - poetry run make -C docs all
#     - mv docs/build/html public
#   artifacts:
#     paths:
#       - public
#   tags:
#     - lab
#     - docker

docker_build:
  stage: DOCKER/BUILD
  script:
    - |
      echo "REGISTRY=${CI_REGISTRY}"
      echo "IMAGE_NAME=${IMAGE_NAME}"
      echo "REPOSITORY=${CI_REGISTRY_IMAGE}"
      docker build \
        --build-arg http_proxy="${http_proxy}" \
        --build-arg https_proxy="${https_proxy}" \
        -t ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA} \
        -f docker/workflow.dockerfile \
        .
  tags:
    - lab
    - shell

docker_publish_latest:
  stage: DOCKER/PUBLISH
  rules:
    - if: '$CI_COMMIT_BRANCH == "main"'
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA}
    - docker tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA} ${CI_REGISTRY_IMAGE}:latest
    - docker push ${CI_REGISTRY_IMAGE}:latest
    - docker rmi -f ${CI_REGISTRY_IMAGE}:latest
  tags:
    - lab
    - shell

docker_publish_release:
  stage: DOCKER/PUBLISH
  rules:
    - if: '$CI_COMMIT_TAG'
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker tag ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA} ${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}
    - docker push ${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}
    - docker rmi -f ${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}
  tags:
    - lab
    - shell

docker_clean_temporary:
  stage: DOCKER/CLEAN
  rules:
    - if: '$CI_COMMIT_BRANCH != "main" && $CI_COMMIT_TAG == ""'
  script:
    - docker rmi -f ${CI_REGISTRY_IMAGE}:${CI_COMMIT_SHORT_SHA}
  tags:
    - lab
    - shell

docker_clean_oldest:
  stage: DOCKER/CLEAN
  rules:
    - if: '$CI_COMMIT_BRANCH == "main"'
    - if: '$CI_COMMIT_TAG'
  script:
    - |
      docker image ls $CI_REGISTRY_IMAGE \
          --format '{{.CreatedAt}}\t{{.ID}}' \
          --no-trunc \
        | sort \
        | cut -f2 \
        | head -n -3 \
        | xargs -r docker rmi -f
  tags:
    - lab
    - shell
